#include "stdafx.h"
#include "iis4ruby_cmn_err.h"
#include "iis4ruby_cmn_process.h"

BOOL StartProcesss( IN LPWSTR lpCmdLine, OUT HANDLE& hChildProcess, OUT HANDLE& hInput, OUT HANDLE& hOutput, OUT HANDLE& hErr ) {

	STARTUPINFO oStInfo	= {
		sizeof( STARTUPINFO ),
		NULL,
		NULL,
		NULL,
		0, 0, 0, 0,
		0, 0,
		0,
		STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES,
		SW_HIDE,
		0,
		NULL,
		NULL,
		NULL,
		NULL
	} ;
	PROCESS_INFORMATION oProcInfo ;
	SECURITY_ATTRIBUTES oSA	= {
		sizeof( SECURITY_ATTRIBUTES ),
		NULL,
		TRUE
	} ;
	SECURITY_ATTRIBUTES oPS	= {
		sizeof( SECURITY_ATTRIBUTES ),
		NULL,
		TRUE
	} ;
	SECURITY_ATTRIBUTES oTS	= {
		sizeof( SECURITY_ATTRIBUTES ),
		NULL,
		TRUE
	} ;
	BOOL bResult ;
	HANDLE hDummyInput ;
	HANDLE hDummyOutput ;
	HANDLE hDummyErr ;
	HANDLE hCurrentProcess ;
	::ZeroMemory( &oProcInfo, sizeof( oProcInfo ) ) ;

	BEGIN_TRY( bExcept ) ;

	bResult	= ::CreatePipe( &hDummyInput, &hOutput, &oSA, 0 ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;
	bResult	= ::CreatePipe( &hInput, &hDummyOutput, &oSA, 0 ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;
	bResult	= ::CreatePipe( &hDummyErr, &hErr, &oSA, 0 ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;

	hCurrentProcess	= ::GetCurrentProcess() ;
	bResult	= ::DuplicateHandle( hCurrentProcess, hInput, hCurrentProcess, NULL, 0, FALSE, DUPLICATE_SAME_ACCESS ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;
	bResult	= ::DuplicateHandle( hCurrentProcess, hOutput, hCurrentProcess, NULL, 0, FALSE, DUPLICATE_SAME_ACCESS ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;
	bResult	= ::DuplicateHandle( hCurrentProcess, hErr, hCurrentProcess, NULL, 0, FALSE, DUPLICATE_SAME_ACCESS ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;

	oStInfo.hStdInput	= hDummyOutput ;
	oStInfo.hStdOutput	= hDummyInput ;
	oStInfo.hStdError	= hDummyErr ;
	bResult	= ::CreateProcess( NULL, lpCmdLine, &oPS, &oTS, TRUE, CREATE_NO_WINDOW | NORMAL_PRIORITY_CLASS, 0, NULL, &oStInfo, &oProcInfo ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;

	::CloseHandle( oProcInfo.hThread ) ;
	::CloseHandle( hDummyOutput ) ;
	::CloseHandle( hDummyInput ) ;
	::CloseHandle( hDummyErr ) ;

	hChildProcess	= oProcInfo.hProcess ;

	END_TRY( bExcept, FALSE ) ;

	return TRUE ;
}