#include "stdafx.h"
#include "iis4ruby_rev1.h"

TCHAR sRubyCmd[ 1024 ] ;
TCHAR sDllName[ 1024 ] ;
TCHAR sRunCmd[ 2048 ] ;
TCHAR sImpRunCmd[ 2048 ] ;

//
// Name  :	GetExtensionVersion
// Param :	HSE_VERSION_INFO* pVer
//
//
BOOL WINAPI GetExtensionVersion(OUT HSE_VERSION_INFO* pVer)
{
	REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("Jn:GetExtensionVersion") ) ;

	pVer->dwExtensionVersion
			= MAKELONG( HSE_VERSION_MINOR, HSE_VERSION_MAJOR ) ;
	strncpy_s(
		pVer->lpszExtensionDesc,
		sizeof( pVer->lpszExtensionDesc ),
		"IIS for Ruby Rev.1",
		( HSE_MAX_EXT_DLL_NAME_LEN - 1 )
	) ;

	REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("I:GetExtensionVersion") ) ;

	return TRUE;
}

//
// Name  :	HttpExtensionProc
// Param :	EXTENSION_CONTROL_BLOCK* pECB
//
//
DWORD WINAPI HttpExtensionProc(IN EXTENSION_CONTROL_BLOCK *pECB)
{
	REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("Jn:HttpExtensionProc") ) ;

	char* pPath ;
	HANDLE hFile ;
	BOOL bResult ;

	BEGIN_TRY( bExcept ) ;

	// PATH擾
	pPath	= strrchr( pECB->lpszPathTranslated, '\\' ) ;
	if( pPath == NULL ) {
		REL_ERR( CAT_REV1, MSG_SYS, A2T( pECB->lpszPathTranslated ) ) ;
		WriteErrorPage( pECB, A2T( pECB->lpszPathTranslated ) ) ;
		return HSE_STATUS_ERROR ;
	}
	pPath++ ;

	// wv\
	if( strncmp( pPath, "help.rb", sizeof( "help.rb" ) ) == 0 ) {
		WriteHelpPage( pECB ) ;
		return HSE_STATUS_SUCCESS ;
	}

	// t@C̑݊mF
	SECURITY_ATTRIBUTES oSA	= {
		sizeof( SECURITY_ATTRIBUTES ) ,
		NULL,
		TRUE
	} ;
	hFile	= ::CreateFileA( pECB->lpszPathTranslated, FILE_READ_DATA | FILE_READ_ATTRIBUTES, FILE_SHARE_READ, &oSA, OPEN_EXISTING, 0, NULL ) ;
	if( hFile == INVALID_HANDLE_VALUE ) {
		REL_SYSTEM() ;
		WriteErrorPage( pECB, _T( "CreateFileA" ) ) ;
		return HSE_STATUS_SUCCESS ;
	}
	::CloseHandle( hFile ) ;

	// Ruby N
	HANDLE hChild ;
	HANDLE hInput ;
	HANDLE hOutput ;
	HANDLE hErr ;
	_stprintf_s( sImpRunCmd, sizeof( sImpRunCmd ), sRunCmd, A2T( pECB->lpszPathTranslated ) ) ;
	bResult	= StartProcesss( sImpRunCmd, hChild, hInput, hOutput, hErr ) ;
	if( !bResult ) {
		REL_SYSTEM() ;
		WriteErrorPage( pECB, _T( "StartProcesss" ) ) ;
		return HSE_STATUS_SUCCESS ;
	}

	// p[^ ruby ɓn
//	::WriteFile( hInput, 
	::CloseHandle( hInput ) ;

	// I܂őҋ@
	::WaitForSingleObject( hChild, INFINITE ) ;

	// ʂ擾
	DWORD nReadSize ;
	DWORD nTmpReadSize ;
	char* pReadData ;

	::ReadFile( hOutput, NULL, 0, &nReadSize, NULL ) ;
	pReadData	= new char[ nReadSize ] ;
	::ReadFile( hOutput, pReadData, nReadSize, &nTmpReadSize, NULL ) ;

	// ʂo͂
	pECB->WriteClient( pECB->ConnID, pReadData, &nTmpReadSize, HSE_IO_SYNC ) ;

	::CloseHandle( hChild ) ;
	::CloseHandle( hOutput ) ;
	::CloseHandle( hErr ) ;

#pragma warning( disable: 4297 )
	END_TRY( bExcept, TRUE ) ;
#pragma warning( default: 4297 )

	REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("I:HttpExtensionProc") ) ;

	return HSE_STATUS_SUCCESS ;
}

//
// Name  :	TerminateExtension
// Param :	DWORD dwFlags
//
//
BOOL WINAPI TerminateExtension(IN DWORD dwFlags)
{
	REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("Jn:TerminateExtension") ) ;

	switch( dwFlags ) {
		case HSE_TERM_ADVISORY_UNLOAD:
			return TRUE;
		case HSE_TERM_MUST_UNLOAD:
			return TRUE;
	}

	REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("I:TerminateExtension") ) ;

	return FALSE;
}
